## hpklinux 4.20.36-g76c09bc

=== hpi-cli-apps/Makefile ===
## linux/hpi-cli-apps/Makefile
##
##    AudioScience HPI driver
##    Copyright (C) 1997-2017  AudioScience Inc. <support@audioscience.com>
##
##    This program is free software; you can redistribute it and/or modify
##    it under the terms of version 2 of the GNU General Public License as
##    published by the Free Software Foundation;
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with this program; if not, write to the Free Software
##    Foundation, Inc., 59 Temple Place, Suite 330,
##    Boston, MA  02111-1307  USA
##

abs-thisdir := $(realpath $(dir $(lastword $(MAKEFILE_LIST))))

.DEFAULT_GOAL := all

-include build_overrides.mk
# hpi_version.mk must exist
include hpi_version.mk
# Include dist file lists
include distfiles.mk

CC = $(CROSS_COMPILE)cc
AR = $(CROSS_COMPILE)ar
LD = $(CROSS_COMPILE)ld

#WARNFULL_CFLAGS = -Wextra -pedantic -std=gnu99 -Wconversion
CFLAGS = -pipe -g -O2 -Wall -DHPI_OS_LINUX -DHPI_BUILD_EXCLUDE_ALL_DEPRECATED \
	$(WARNFULL_CFLAGS)

# Find out if this is a 64-bit build
ar_gcc_arch=$(shell $(CC) -dumpmachine | awk -F- '{ print $$1 }')
ifeq ($(ar_gcc_arch),x86_64)
	CFLAGS += -D HPI_BUILD_64BIT
endif

bins = asihpitest asihpiassert asihpitune asihpirec asihpiplay \
	asi_firmware_updater asihpibl asihpirds asihpi_si4688
install-prefix ?= /usr/local
bin-install-dir ?= $(install-prefix)/bin

asihpirds: $(asihpirds-srcs)
	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm

asihpi_si4688: $(asihpi-si4688-srcs)
	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm

asihpitest: $(asihpitest-srcs)
	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm

asihpirec: $(asihpirec-srcs)
	$(CC) $(CFLAGS) $(INCLUDES) -DASIHPIREC -o $@ $^ -lhpi -lm

asihpiplay: $(asihpirec-srcs)
	$(CC) $(CFLAGS) $(INCLUDES) -DASIHPIPLAY -o $@ $^ -lhpi -lm

asihpitune: $(asihpitune-srcs)
	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm

asihpiassert: $(asihpiassert-srcs)
	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm

asihpibl: $(asihpibl-srcs)
	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm

asi_firmware_updater: $(asi-firmware-updater-srcs)
	$(CC) $(CFLAGS) $(INCLUDES) -D HPI_BUILD_INCLUDE_INTERNAL -o $@ $^ -lhpiudp -lm -lpthread

setup: $(src-dist-files)

build: libs $(bins)

install-bins: $(bins)
	install -d $(DESTDIR)$(bin-install-dir)
	install -m 0755 $^ $(DESTDIR)$(bin-install-dir)/

install: build install-bins

clean distclean:
	rm -f *~ *.d *.o $(bins)

all: setup build

.PHONY: all libs setup build clean distclean

# Find out if there's sibling hpi-lib directory with a version matching ours
hpi-lib-version = $(shell cat $(abs-thisdir)/../hpi-lib/hpi_version.mk | head -n 1 | cut -d ' ' -f 3)

ifeq ($(hpi-lib-version),$(hpi-version-string))
# When in staging directory or in hpk package look for libraries and headers in the hpi-lib subtarget
CFLAGS += -L$(abs-thisdir)/../hpi-lib
INCLUDES += -I$(abs-thisdir)/../hpi-lib

libs:
	$(MAKE) -C $(abs-thisdir)/../hpi-lib build
else
INCLUDES += -I$(install-prefix)/include/asihpi

libs:
	#dummy
endif

=== hpi-lib/Makefile ===
## linux/hpi-lib/Makefile
##
##    AudioScience HPI driver
##    Copyright (C) 1997-2017  AudioScience Inc. <support@audioscience.com>
##
##    This program is free software; you can redistribute it and/or modify
##    it under the terms of version 2 of the GNU General Public License as
##    published by the Free Software Foundation;
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##

abs-thisdir := $(realpath $(dir $(lastword $(MAKEFILE_LIST))))
set-intersection = $(filter $(1),$(2))

.DEFAULT_GOAL := all

-include build_overrides.mk
# hpi_version.mk must exist
include hpi_version.mk
# Include dist file lists
include distfiles.mk

CC = $(CROSS_COMPILE)cc
AR = $(CROSS_COMPILE)ar
LD = $(CROSS_COMPILE)ld
LDCONFIG = $(CROSS_COMPILE)ldconfig
ARFLAGS = crv

# https://www.gnu.org/software/libtool/manual/libtool.html#Release-numbers
LIB_VER_MAJOR = 10
LIB_VER_MINOR = 3
LIB_VER_INC = 0
lib-version-suffix = $(LIB_VER_MAJOR).$(LIB_VER_MINOR).$(LIB_VER_INC)

#WARNFULL_CFLAGS = -Wextra -pedantic -std=gnu99 -Wconversion
CFLAGS += -ggdb -fPIC -pipe -Wall $(WARNFULL_CFLAGS) \
	-DHPI_BUILD_DEBUG \
	-DHPI_BUILD_INCLUDE_INTERNAL \
	-DHPI_BUILD_EXCLUDE_ALL_DEPRECATED \
	-DnotHPI_BUILD_HPIDUMP 

install-prefix ?= /usr/local
include-install-dir ?= $(install-prefix)/include/asihpi

static-libs = libhpi.a libhpiudp.a libhpimux.a
dynamic-libs = libhpi.so libhpiudp.so libhpimux.so
libs = $(static-libs) $(dynamic-libs)

# Find out if this is a 64-bit build
ar_gcc_arch=$(shell $(CC) -dumpmachine | awk -F- '{ print $$1 }')
ifeq ($(ar_gcc_arch),x86_64)
	CFLAGS += -D HPI_BUILD_64BIT
	lib-install-dir-candidates = $(install-prefix)/lib64 $(install-prefix)/lib
else
	lib-install-dir-candidates = $(install-prefix)/lib
endif

#### Detect library destination directory
# Use ldconfig to get a list of directories searched for dynamic libraries
# then intersect it with a list of candidates and take the first.
sys-lib-paths = $(shell $(LD) --verbose | grep SEARCH_DIR | sed 's/SEARCH_DIR("=\?\([^"]\+\)"); */\1\n/g' | grep -vE '^$$')
lib-install-dir ?= $(firstword $(call set-intersection,$(sys-lib-paths),$(lib-install-dir-candidates)))

ifeq ($(lib-install-dir),)
	$(error No suitable library destination directory found)
endif

%.d : %.c
	set -e; $(CC) -M $(CFLAGS) -I. $(INCLUDES) $< > $@

# libhpi: Local adapters only
libhpi-build-prefix = build/libhpi
libhpi-objs = $(addprefix $(libhpi-build-prefix)/,hpiwrap.o $(patsubst %.c,%.o,$(filter %c,$(common-sources))))
$(libhpi-objs) : $(libhpi-build-prefix)/%.o : $(abs-thisdir)/%.c
	mkdir -p $(dir $@)
	$(CC) $(CFLAGS) -I. $(INCLUDES) -c $< -o $@
libhpi.a: $(libhpi-objs)
	-rm -f $@
	$(AR) $(ARFLAGS) $@ $^
libhpi.so: $(libhpi-objs)
	-rm -f $@
	$(CC) --shared -fPIC -Wl,-soname,$@.$(LIB_VER_MAJOR) $^ -lm -lrt -o $@.$(lib-version-suffix)
	ln -sf $@.$(lib-version-suffix) $@.$(LIB_VER_MAJOR)
	ln -sf $@.$(lib-version-suffix) $@

# libhpiudp: Network adapters only
libhpiudp-build-prefix = build/libhpiudp
libhpiudp-objs = $(addprefix $(libhpiudp-build-prefix)/,hpiudp.o hpicmn.o hpifilestore.o hpios.o \
	hpiudp_cache.o $(patsubst %.c,%.o,$(filter %c,$(common-sources))))
$(libhpiudp-objs) : $(libhpiudp-build-prefix)/%.o : $(abs-thisdir)/%.c
	mkdir -p $(dir $@)
	$(CC) $(CFLAGS) -I. $(INCLUDES) -c $< -o $@
libhpiudp.a: $(libhpiudp-objs)
	-rm -f $@
	$(AR) $(ARFLAGS) $@ $^
libhpiudp.so: $(libhpiudp-objs)
	-rm -f $@
	$(CC) --shared -fPIC -Wl,-soname,$@.$(LIB_VER_MAJOR) $^ -lm -lrt -lpthread -o $@.$(lib-version-suffix)
	ln -sf $@.$(lib-version-suffix) $@.$(LIB_VER_MAJOR)
	ln -sf $@.$(lib-version-suffix) $@

# libhpimux: Mux messages for both kinds of adapters
libhpimux-build-prefix = build/libhpimux
libhpimux-objs = $(addprefix $(libhpimux-build-prefix)/,hpiwrap.o hpimux.o hpiudp.o hpicmn.o hpios.o \
	hpissx2.o hpifilestore.o hpiudp_cache.o $(patsubst %.c,%.o,$(filter %c,$(common-sources))))
$(libhpimux-objs) : $(libhpimux-build-prefix)/%.o : $(abs-thisdir)/%.c
	mkdir -p $(dir $@)
	$(CC) $(CFLAGS) -DHPI_BUILD_MULTIINTERFACE -DHPI_BUILD_SSX2 -I. $(INCLUDES) -c $< -o $@
libhpimux.a: $(libhpimux-objs)
	-rm -f $@
	$(AR) $(ARFLAGS) $@ $^
libhpimux.so: $(libhpimux-objs)
	-rm -f $@
	$(CC) --shared -fPIC -Wl,-soname,$@.$(LIB_VER_MAJOR) $^ -lm -lrt -lpthread -o $@.$(lib-version-suffix)
	ln -sf $@.$(lib-version-suffix) $@.$(LIB_VER_MAJOR)
	ln -sf $@.$(lib-version-suffix) $@

setup: $(src-dist-files)

build: setup $(libs)

install-headers: $(installed-headers)
	install -d $(DESTDIR)$(include-install-dir)
	install -m 0644 $^ $(DESTDIR)$(include-install-dir)/

install-static: $(static-libs)
	install -d $(DESTDIR)$(lib-install-dir)
	install -m 0755 $^ $(DESTDIR)$(lib-install-dir)/

install-dynamic: $(dynamic-libs)
	install -d $(DESTDIR)$(lib-install-dir)
	# Copy lib*.so.MAJOR.MINOR.INC
	install -m 0755 $(addsuffix .$(lib-version-suffix),$^) $(DESTDIR)$(lib-install-dir)/
	# Copy (and preserve) symlinks to libraries
	cp -P $^ $(addsuffix .*,$^) $(DESTDIR)$(lib-install-dir)/

install: install-headers install-static install-dynamic

distclean clean:
	rm -f *~ *.d *.o *.a *.so

all: setup $(libs)

.PHONY: all build clean install install-headers install-static install-dynamic

## hpklinux 4.20.38

=== alsa-drv/Makefile ===
# This is kbuild makefile for use with kernel build system
#
# Copyright (C) 1997-2017  AudioScience Inc. <support@audioscience.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License as
# published by the Free Software Foundation;
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# Usage:
# make -C <path-to-kernel-source> SUBDIRS=$PWD modules
# If you used O=<path-to-build-directory> for kernel build, use it here too

ifdef KBUILD_VERBOSE
# then we are coming from the kernel build sytem

snd-asihpi-objs := asihpi.o hpicmn.o hpifunc.o hpidebug.o  hpimsgx.o hpios.o\
		hpi6000.o hpi6205.o hpi6700.o hpidspcd.o hpimsginit.o hpioctl.o

obj-m += snd-asihpi.o

ifeq ($(shell egrep -qw "snd_pcm_stop_xrun" $(realpath $(srctree))/include/sound/pcm.h; echo $$?),0)
	   have-snd-pcm-stop-xrun := 1
else
	   have-snd-pcm-stop-xrun := 0
endif

ifeq ($(shell egrep -qw "pcm_format_to_bits" $(realpath $(srctree))/include/sound/pcm.h; echo $$?),0)
	   have-pcm-format-to-bits := 1
else
	   have-pcm-format-to-bits := 0
endif

ifeq ($(shell egrep -qw "snd_ctl_enum_info" $(realpath $(srctree))/include/sound/control.h; echo $$?),0)
	   have-snd-ctl-enum-info := 1
else
	   have-snd-ctl-enum-info := 0
endif

ifeq ($(shell egrep -qw "snd_card_new" $(realpath $(srctree))/include/sound/core.h; echo $$?),0)
	   have-snd-card-new := 1
else
	   have-snd-card-new := 0
endif

# Allow #include <header>  to get header from this build dir
EXTRA_CFLAGS = -DKERNEL_ALSA_BUILD -I$(M) \
	-DHAVE_SND_PCM_STOP_XRUN=$(have-snd-pcm-stop-xrun) \
	-DHAVE_PCM_FORMAT_TO_BITS=$(have-pcm-format-to-bits) \
	-DHAVE_SND_CTL_ENUM_INFO=$(have-snd-ctl-enum-info) \
	-DHAVE_SND_CARD_NEW=$(have-snd-card-new)

else
# Use the autoconf generated makefile for setup, install, dist targets etc.
include extra.mk
endif

=== asi-python/Makefile ===
## python/Makefile
##
##    AudioScience HPI driver
##    Copyright (C) 1997-2017  AudioScience Inc. <support@audioscience.com>
##
##    This program is free software; you can redistribute it and/or modify
##    it under the terms of version 2 of the GNU General Public License as
##    published by the Free Software Foundation;
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##

abs-thisdir := $(realpath $(dir $(lastword $(MAKEFILE_LIST))))

.DEFAULT_GOAL := all

-include build_overrides.mk
# hpi_version.mk must exist
include hpi_version.mk
# Include dist file lists
include distfiles.mk

precious-files = build_overrides.mk
precious-files += $(setup-files)

all: setup

setup: $(setup-files)

build install: setup
	python setup.py $(OPTS) $@ $(CMD_OPTS)

clean distclean:
	rm -rf $(filter-out $(precious-files),$(wildcard *))

.PHONY: all setup build install dist clean distclean

=== deb/Makefile ===
## deb/Makefile
##
##    AudioScience HPI driver
##    Copyright (C) 1997-2017  AudioScience Inc. <support@audioscience.com>
##
##    This program is free software; you can redistribute it and/or modify
##    it under the terms of version 2 of the GNU General Public License as
##    published by the Free Software Foundation;
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with this program; if not, write to the Free Software
##    Foundation, Inc., 59 Temple Place, Suite 330,
##    Boston, MA  02111-1307  USA
##

.DEFAULT_GOAL := setup

abs-thisdir := $(realpath $(dir $(lastword $(MAKEFILE_LIST))))
dist-dir-prefix = ../

include hpi_version.mk

distro-series = buster

distro-archs = amd64 i386

series-from-path = $(notdir $(patsubst %/,%,$(dir $(1))))
debpkg-changelog-files = $(addsuffix -changelog.in,$(debpkg-dir-names))

deb-build-path-prefix = $(abs-thisdir)/build/$(hpi-repo-version-string)
dest-debpkg-dirs = $(foreach series,$(distro-series), $(addprefix $(deb-build-path-prefix)/$(series)/,$(debpkg-dir-names)))

pbuilder-base-image-files = $(addprefix $(HOME)/pbuilder/, $(foreach serie,$(distro-series), $(foreach arch,$(distro-archs), $(addprefix $(serie)-$(arch), -base.tgz))))

srcdeb-prefixes = asihpi-dkms snd-asihpi-dkms asihpi-meta hpklinux python-audioscience asihpi-utils
run-all-pbuilder-dist = $(foreach serie,$(distro-series), $(foreach arch,$(distro-archs), $(foreach desc_file_prefix,$(srcdeb-prefixes), ./pbuilder-dist $(serie) $(arch) build $(wildcard $(deb-build-path-prefix)/$(serie)/$(desc_file_prefix)*.dsc); )))

get-base-image-distro = $(shell echo $(notdir $@) | cut -d '-' --output-delimiter=' ' -f1)
get-base-image-arch = $(shell echo $(notdir $@) | cut -d '-' --output-delimiter=' ' -f2)

include deb.mk

%/pkgsrc-build.stamp: %
	cd $(dir $@) && debuild -i -us -uc -S -d && touch $@

setup: $(debpkg-changelog-files) $(HOME)/.pbuilderrc $(HOME)/.pbuilder-hooks/D10apt-ftparchive

pkgsrc-build: setup $(addsuffix /pkgsrc-build.stamp,$(dest-debpkg-dirs))

$(HOME)/.pbuilderrc: pbuilderrc
	cp -a pbuilderrc $(HOME)/.pbuilderrc

$(HOME)/.pbuilder-hooks/D10apt-ftparchive: pbuilder-hook
	mkdir -p $(HOME)/.pbuilder-hooks
	cp -a pbuilder-hook $(HOME)/.pbuilder-hooks/D10apt-ftparchive

./pbuilder-dist:
	cp -a $(shell which pbuilder-dist) ./
	patch <pbuilder-dist.patch

$(pbuilder-base-image-files): setup ./pbuilder-dist
	./pbuilder-dist $(shell echo $(notdir $@) | cut -d '-' --output-delimiter=' ' -f1,2) create

pkgbin-build: pkgsrc-build $(pbuilder-base-image-files)
	$(call run-all-pbuilder-dist)

clean:
	rm -rf $(dest-debpkg-dirs)

distclean:
	rm -rf $(abs-thisdir)/build

.PHONY: setup pkgsrc-build pkgbin-build clean distclean

=== hpi-cli-apps/Makefile ===
--- 
+++ 
@@ -33,12 +33,12 @@
 LD = $(CROSS_COMPILE)ld
 
 #WARNFULL_CFLAGS = -Wextra -pedantic -std=gnu99 -Wconversion
-CFLAGS = -pipe -g -O2 -Wall -DHPI_OS_LINUX -DHPI_BUILD_EXCLUDE_ALL_DEPRECATED \
+CFLAGS += -pipe -g -O2 -Wall -DHPI_OS_LINUX -DHPI_BUILD_EXCLUDE_ALL_DEPRECATED \
 	$(WARNFULL_CFLAGS)
 
 # Find out if this is a 64-bit build
 ar_gcc_arch=$(shell $(CC) -dumpmachine | awk -F- '{ print $$1 }')
-ifeq ($(ar_gcc_arch),x86_64)
+ifneq (,$(filter $(ar_gcc_arch),x86_64 aarch64))
 	CFLAGS += -D HPI_BUILD_64BIT
 endif
 
@@ -48,31 +48,31 @@
 bin-install-dir ?= $(install-prefix)/bin
 
 asihpirds: $(asihpirds-srcs)
-	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm
+	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm
 
 asihpi_si4688: $(asihpi-si4688-srcs)
-	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm
+	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm
 
 asihpitest: $(asihpitest-srcs)
-	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm
+	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm
 
 asihpirec: $(asihpirec-srcs)
-	$(CC) $(CFLAGS) $(INCLUDES) -DASIHPIREC -o $@ $^ -lhpi -lm
+	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDES) -DASIHPIREC -o $@ $^ -lhpi -lm
 
 asihpiplay: $(asihpirec-srcs)
-	$(CC) $(CFLAGS) $(INCLUDES) -DASIHPIPLAY -o $@ $^ -lhpi -lm
+	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDES) -DASIHPIPLAY -o $@ $^ -lhpi -lm
 
 asihpitune: $(asihpitune-srcs)
-	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm
+	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm
 
 asihpiassert: $(asihpiassert-srcs)
-	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm
+	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm
 
 asihpibl: $(asihpibl-srcs)
-	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm
+	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm
 
 asi_firmware_updater: $(asi-firmware-updater-srcs)
-	$(CC) $(CFLAGS) $(INCLUDES) -D HPI_BUILD_INCLUDE_INTERNAL -o $@ $^ -lhpiudp -lm -lpthread
+	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDES) -D HPI_BUILD_INCLUDE_INTERNAL -o $@ $^ -lhpiudp -lm -lpthread
 
 setup: $(src-dist-files)

=== hpi-drv/Makefile ===
# This is kbuild makefile for use with kernel build system
#
# Copyright (C) 1997-2017  AudioScience Inc. <support@audioscience.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License as
# published by the Free Software Foundation;
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# Usage:
# make -C <path-to-kernel-source> SUBDIRS=$PWD modules
# If you used O=<path-to-build-directory> for kernel build, use it here too

ifdef KBUILD_VERBOSE
# then we are coming from the kernel build system

include $(M)/hpi_version.mk

asihpi-objs := hpimod.o hpioctl.o hpicmn.o hpifunc.o hpidebug.o hpimsgx.o hpios.o\
			hpi6000.o hpi6205.o hpi6700.o hpidspcd.o hpimsginit.o

obj-m += asihpi.o

EXTRA_CFLAGS = -DDRIVER_VERSION=$(hpi-version-string) \
	-DHPI_OS_LINUX_KERNEL \
	-DHPI_BUILD_DEBUG \
	-DHPI_BUILD_INCLUDE_HPI6000 \
	-DHPI_BUILD_INCLUDE_HPI6205 \
	-DHPI_BUILD_INCLUDE_HPI6700 \
	-DHPI_BUILD_INCLUDE_INTERNAL \
	-DHPI_BUILD_EXCLUDE_ALL_DEPRECATED \
	-O \
	-I$(M)

else
# Use the autoconf generated makefile for setup, install, dist targets etc.
include extra.mk
endif

=== hpi-lib/Makefile ===
--- 
+++ 
@@ -52,7 +52,7 @@
 
 # Find out if this is a 64-bit build
 ar_gcc_arch=$(shell $(CC) -dumpmachine | awk -F- '{ print $$1 }')
-ifeq ($(ar_gcc_arch),x86_64)
+ifneq (,$(filter $(ar_gcc_arch),x86_64 aarch64))
 	CFLAGS += -D HPI_BUILD_64BIT
 	lib-install-dir-candidates = $(install-prefix)/lib64 $(install-prefix)/lib
 else
@@ -83,7 +83,7 @@
 	$(AR) $(ARFLAGS) $@ $^
 libhpi.so: $(libhpi-objs)
 	-rm -f $@
-	$(CC) --shared -fPIC -Wl,-soname,$@.$(LIB_VER_MAJOR) $^ -lm -lrt -o $@.$(lib-version-suffix)
+	$(CC) $(LDFLAGS) --shared -fPIC -Wl,-soname,$@.$(LIB_VER_MAJOR) $^ -lm -lrt -o $@.$(lib-version-suffix)
 	ln -sf $@.$(lib-version-suffix) $@.$(LIB_VER_MAJOR)
 	ln -sf $@.$(lib-version-suffix) $@
 
@@ -99,7 +99,7 @@
 	$(AR) $(ARFLAGS) $@ $^
 libhpiudp.so: $(libhpiudp-objs)
 	-rm -f $@
-	$(CC) --shared -fPIC -Wl,-soname,$@.$(LIB_VER_MAJOR) $^ -lm -lrt -lpthread -o $@.$(lib-version-suffix)
+	$(CC) $(LDFLAGS) --shared -fPIC -Wl,-soname,$@.$(LIB_VER_MAJOR) $^ -lm -lrt -lpthread -o $@.$(lib-version-suffix)
 	ln -sf $@.$(lib-version-suffix) $@.$(LIB_VER_MAJOR)
 	ln -sf $@.$(lib-version-suffix) $@
 
@@ -115,7 +115,7 @@
 	$(AR) $(ARFLAGS) $@ $^
 libhpimux.so: $(libhpimux-objs)
 	-rm -f $@
-	$(CC) --shared -fPIC -Wl,-soname,$@.$(LIB_VER_MAJOR) $^ -lm -lrt -lpthread -o $@.$(lib-version-suffix)
+	$(CC) $(LDFLAGS) --shared -fPIC -Wl,-soname,$@.$(LIB_VER_MAJOR) $^ -lm -lrt -lpthread -o $@.$(lib-version-suffix)
 	ln -sf $@.$(lib-version-suffix) $@.$(LIB_VER_MAJOR)
 	ln -sf $@.$(lib-version-suffix) $@

=== rpm/Makefile ===
## linux/rpm/Makefile
##
##    AudioScience HPI driver
##    Copyright (C) 1997-2018  AudioScience Inc. <support@audioscience.com>
##
##    This program is free software; you can redistribute it and/or modify
##    it under the terms of version 2 of the GNU General Public License as
##    published by the Free Software Foundation;
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##

-include build_overrides.mk
# hpi_version.mk must exist
include hpi_version.mk
# Include dist file lists
include distfiles.mk

.DEFAULT_GOAL := all

RPM_ROOT=$(shell pwd)/rpmbuild

rpm-build: hpklinux.spec
	rm -rf $(RPM_ROOT)
	mkdir -p $(RPM_ROOT)/{RPMS,SPECS,SRPMS,SOURCES}
	ln -sf $(shell pwd)/.. $(RPM_ROOT)/BUILD
	echo '%_topdir ${RPM_ROOT}' > ~/.rpmmacros
	rpmbuild -ba hpklinux.spec
	rm ~/.rpmmacros

setup: $(src-dist-files)

all: setup rpm-build

.PHONY: all rpm-build build

=== alsa-drv/firmware/Makefile ===
## firmware/Makefile
##
##    AudioScience HPI driver
##    Copyright (C) 1997-2017  AudioScience Inc. <support@audioscience.com>
##
##    This program is free software; you can redistribute it and/or modify
##    it under the terms of version 2 of the GNU General Public License as
##    published by the Free Software Foundation;
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with this program; if not, write to the Free Software
##    Foundation, Inc., 59 Temple Place, Suite 330,
##    Boston, MA  02111-1307  USA
##

include hpi_version.mk
# Include common firmware file lists
include distfiles.mk

precious-files += $(firmware-all-dist-files)

bin-install-ver-suffix = asihpi/$(shell echo $(hpi-version-string) | cut -d . -f1).$(shell echo $(hpi-version-string) | cut -d . -f2)
bin-install-base-path = $(shell sh firmwaredir.sh)
bin-install-path = $(bin-install-base-path)/$(bin-install-ver-suffix)

install: $(firmware-all-dist-files)
	install -d $(bin-install-path)
	install -m 0444 $(firmware-dsp-bins) $(bin-install-path)
	install -m 0655 dspinfo.py $(bin-install-path)

uninstall:
	rm -f $(addprefix $(bin-install-path)/,$(firmware-all-dist-files))

clean distclean:
	rm -rf $(filter-out $(precious-files),$(wildcard *))

.PHONY: install uninstall clean distclean

=== deb/asihpi-dkms/Makefile ===
DESTDIR ?=

.PHONY: install
install:
	install -D -m 644 src/*.c src/*.h src/hpi_version.mk "$(DESTDIR)"
	install -m 644 src/Makefile "$(DESTDIR)"

=== deb/asihpi-dkms/src/Makefile ===
# If KERNELRELEASE is defined, we've been invoked from the
# kernel build system and can use its language
ifneq ($(KERNELRELEASE),)

asihpi-objs := hpimod.o hpicmn.o hpifunc.o hpidebug.o  hpimsgx.o hpios.o\
           hpi6000.o hpi6205.o hpi6700.o hpidspcd.o hpimsginit.o\
           hpioctl.o

obj-m := asihpi.o

EXTRA_CFLAGS = -DDRIVER_VERSION=@VERSION@ \
	-DHPI_OS_LINUX_KERNEL \
	-DHPI_BUILD_DEBUG \
	-DHPI_BUILD_INCLUDE_HPI6000 \
	-DHPI_BUILD_INCLUDE_HPI6205 \
	-DHPI_BUILD_INCLUDE_HPI6700 \
	-DHPI_BUILD_INCLUDE_INTERNAL \
	-DHPI_BUILD_EXCLUDE_ALL_DEPRECATED \
	-O \
	-I$(M)

# otherwise we were called directly from the command
# line; invoke the kernel build system.
else
KERNELDIR ?= /lib/modules/$(shell uname -r)/build

modules modules_install clean::
	echo $(CURDIR)
	make -C $(KERNELDIR) M=$(CURDIR) $@

clean::
	rm -f *.o Module.markers modules.order

endif

=== deb/snd-asihpi-dkms/src/Makefile ===
# If KERNELRELEASE is defined, we've been invoked from the
# kernel build system and can use its language
ifneq ($(KERNELRELEASE),)


snd-asihpi-objs := asihpi.o hpicmn.o hpifunc.o hpidebug.o  hpimsgx.o hpios.o\
           hpi6000.o hpi6205.o hpi6700.o hpidspcd.o hpimsginit.o\
           hpioctl.o

obj-m := snd-asihpi.o

EXTRA_CFLAGS = -DKERNEL_ALSA_BUILD -I$(M)

# otherwise we were called directly from the command
# line; invoke the kernel build system.
else
KERNELDIR ?= /lib/modules/$(shell uname -r)/build

modules modules_install clean::
	echo $(CURDIR)
	make -C $(KERNELDIR) M=$(CURDIR) $@

clean::
	rm -f *.o Module.markers modules.order

endif

=== deb/asihpi-dkms/debian/control ===
Source: asihpi-dkms-4.20
Section: sound
Priority: optional
Build-Depends: debhelper (>= 9), dkms (>= 2.1.0.0)
Maintainer: AudioScience Linux developers <support@audioscience.com>
Standards-Version: 3.9.7

Package: asihpi-dkms-4.20
Architecture: all
Depends: ${misc:Depends}
Recommends: python
Provides: asihpi-driver
Conflicts: asihpi-driver
Description: HPI driver for AudioScience cards - dkms source
 Contains the driver sources and DKMS configuration, plus
 card firmware and udev rule

=== deb/asihpi-libs/debian/control ===
Source: hpklinux
Section: sound
Priority: optional
# FIXME: correct build-depends
Build-Depends: debhelper (>= 9)
Maintainer: AudioScience Linux developers <support@audioscience.com>
Standards-Version: 3.9.7

Package: libhpi
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: libraries for the AudioScience HPI API
 This package contains the HPI library for access to
 locally installed AudioScience sound cards only.

Package: libhpiudp
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: libraries for  AudioScience HPI API including networking
 This package contains the HPI library including access to
 AudioScience networked sound adapters.

Package: libhpi-dev
Architecture: any
Depends: ${misc:Depends}, libhpi (= ${binary:Version}), libhpiudp (= ${binary:Version})
Section: libdevel
Description: development files for libhpi and libhpiudp
 This package contains the development files needed to build programs
 using the HPI C API.

=== deb/asihpi-meta/debian/control ===
Source: asihpi-meta-4
Section: sound
Priority: optional
Maintainer: AudioScience Linux Developers <linux@audioscience.com>
Build-Depends: debhelper (>= 9.0.0)
Standards-Version: 3.9.7
#Homepage: <insert the upstream URL, if relevant>

Package: snd-asihpi-dkms-4
Architecture: all
Conflicts: asihpi-dkms-4
Depends: ${misc:Depends}, snd-asihpi-dkms-4.20
Description: ALSA driver for AudioScience cards
 This is a metapackage for users that want auto updates across minor versions.

Package: asihpi-dkms-4
Architecture: all
Conflicts: snd-asihpi-dkms-4
Depends: ${misc:Depends}, asihpi-dkms-4.20
Description: HPI driver for AudioScience cards
 This is a metapackage for users that want auto updates across minor versions.

=== deb/asihpi-utils/debian/control ===
Source: asihpi-utils
Section: sound
Priority: optional
Build-Depends: debhelper (>= 9), libhpi-dev (>= 4.20)
Maintainer: AudioScience Linux developers <support@audioscience.com>
Standards-Version: 3.9.7

Package: asihpi-utils
Architecture: any
Depends: ${misc:Depends}, libhpi (= ${binary:Version}), libhpiudp (= ${binary:Version})
Description: utilities for AudioScience sound cards
 This package contains control and test programs AudioScience cards,
 and firmware update utility for networked audio adapters.

=== deb/python-audioscience/debian/control ===
Source: python-audioscience
Section: python
Priority: optional
Build-Depends: debhelper (>= 9), python2, python3-all, python-setuptools, python3-setuptools
Maintainer: AudioScience Linux developers <linux@audioscience.com>
Standards-Version: 3.9.7
X-Python-Version: >= 2.7
X-Python3-Version: >= 3.2

Package: python2-audioscience
Architecture: all
Depends: ${python2:Depends}, ${misc:Depends}, libhpi, libhpiudp
Description: Python binding for AudioScience HPI API
 audioscience.hpi - python2 bindings to HPI library

Package: python3-audioscience
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}, libhpi, libhpiudp
Description: Python binding for AudioScience HPI API
 audioscience.hpi - python bindings to HPI library

Package: python-audioscience
Architecture: all
Depends: ${python2:Depends}, ${misc:Depends}, python, python2-audioscience, python-tk
Description: Python scripts for AudioScience HPI API
 hpicontrol - to set/get controls, attributes, adapter mode
 hpimixer - Tk gui control and monitoring of mixer

=== deb/snd-asihpi-dkms/debian/control ===
Source: snd-asihpi-dkms-4.20
Section: sound
Priority: optional
Build-Depends: debhelper (>= 9), dkms (>= 2.1.0.0)
Maintainer: AudioScience Linux developers <support@audioscience.com>
Standards-Version: 3.9.7

Package: snd-asihpi-dkms-4.20
Architecture: all
Provides: asihpi-driver
Conflicts: asihpi-driver
Depends: ${misc:Depends}
Recommends: python
Description: ALSA driver for AudioScience cards
 Contains the driver sources and DKMS configuration, plus
 card firmware

=== deb/asihpi-dkms/debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

VERSION	:= $(shell dpkg-parsechangelog | sed -nr  '/^Source:/s/Source: [a-z-]*(.*)/\1/p')

%:
	dh $@ --with dkms

override_dh_install:
	dh_install src/*.h src/*.c src/*.sh src/Makefile src/hpi_version.mk usr/src/asihpi-$(VERSION)/
	dh_install firmware/*.bin firmware/dspinfo.py lib/firmware/asihpi/$(VERSION)/
	cp src/asihpi.rules src/45-asihpi.rules
	dh_install src/45-asihpi.rules lib/udev/rules.d/
	rm src/45-asihpi.rules


override_dh_dkms:
	dh_dkms -V $(VERSION)

# do nothing
override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_install override_dh_auto_clean:

=== deb/asihpi-libs/debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -D src -- install-prefix=/usr lib-install-dir=/usr/lib

override_dh_auto_install:
	dh_auto_install -D src -- install-prefix=/usr lib-install-dir=/usr/lib

=== deb/asihpi-utils/debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -D src -- install-prefix=/usr

override_dh_auto_install:
	dh_auto_install -D src -- install-prefix=/usr

=== deb/python-audioscience/debian/rules ===
#! /usr/bin/make -f
# rules using pybuild, not available on Ubuntu 12.04

# export DH_VERBOSE = 1

%:
	dh $@ --with=python2,python3 --buildsystem=pybuild

=== deb/snd-asihpi-dkms/debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

VERSION	:= $(shell dpkg-parsechangelog | sed -nr  '/^Source:/s/Source: [a-z-]*(.*)/\1/p')

%:
	dh $@ --with dkms

override_dh_install:
	dh_install src/*.h src/*.c src/*.sh src/Makefile src/hpi_version.mk usr/src/snd-asihpi-$(VERSION)/
	dh_install firmware/*.bin firmware/dspinfo.py lib/firmware/asihpi/$(VERSION)/

override_dh_dkms:
	dh_dkms -V $(VERSION)

# do nothing
override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_install override_dh_auto_clean:

## hpklinux 4.20.43

=== alsa-drv/Makefile ===
--- 
+++ 
@@ -15,13 +15,25 @@
 # make -C <path-to-kernel-source> SUBDIRS=$PWD modules
 # If you used O=<path-to-build-directory> for kernel build, use it here too
 
-ifdef KBUILD_VERBOSE
+ifneq ($(or $(KBUILD_MODULES),$(KBUILD_VERBOSE),$(KBUILD_EXTMOD)),)
 # then we are coming from the kernel build sytem
 
 snd-asihpi-objs := asihpi.o hpicmn.o hpifunc.o hpidebug.o  hpimsgx.o hpios.o\
 		hpi6000.o hpi6205.o hpi6700.o hpidspcd.o hpimsginit.o hpioctl.o
 
 obj-m += snd-asihpi.o
+
+ifeq ($(shell egrep -qw "pci_set_consistent_dma_mask" $(realpath $(srctree))/include/linux/*.h; echo $$?),0)
+	   have-pci-set-consistent-dma-mask := 1
+else
+	   have-pci-set-consistent-dma-mask := 0
+endif
+
+ifeq ($(shell egrep -qw "pci_set_dma_mask" $(realpath $(srctree))/include/linux/*.h; echo $$?),0)
+	   have-pci-set-dma-mask := 1
+else
+	   have-pci-set-dma-mask := 0
+endif
 
 ifeq ($(shell egrep -qw "snd_pcm_stop_xrun" $(realpath $(srctree))/include/sound/pcm.h; echo $$?),0)
 	   have-snd-pcm-stop-xrun := 1
@@ -49,6 +61,8 @@
 
 # Allow #include <header>  to get header from this build dir
 EXTRA_CFLAGS = -DKERNEL_ALSA_BUILD -I$(M) \
+	-DHAVE_PCI_SET_CONSISTENT_DMA_MASK=$(have-pci-set-consistent-dma-mask) \
+	-DHAVE_PCI_SET_DMA_MASK=$(have-pci-set-dma-mask) \
 	-DHAVE_SND_PCM_STOP_XRUN=$(have-snd-pcm-stop-xrun) \
 	-DHAVE_PCM_FORMAT_TO_BITS=$(have-pcm-format-to-bits) \
 	-DHAVE_SND_CTL_ENUM_INFO=$(have-snd-ctl-enum-info) \

=== hpi-drv/Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # make -C <path-to-kernel-source> SUBDIRS=$PWD modules
 # If you used O=<path-to-build-directory> for kernel build, use it here too
 
-ifdef KBUILD_VERBOSE
+ifneq ($(or $(KBUILD_MODULES),$(KBUILD_VERBOSE),$(KBUILD_EXTMOD)),)
 # then we are coming from the kernel build system
 
 include $(M)/hpi_version.mk
@@ -25,6 +25,18 @@
 
 obj-m += asihpi.o
 
+ifeq ($(shell egrep -qw "pci_set_consistent_dma_mask" $(realpath $(srctree))/include/linux/*.h; echo $$?),0)
+	   have-pci-set-consistent-dma-mask := 1
+else
+	   have-pci-set-consistent-dma-mask := 0
+endif
+
+ifeq ($(shell egrep -qw "pci_set_dma_mask" $(realpath $(srctree))/include/linux/*.h; echo $$?),0)
+	   have-pci-set-dma-mask := 1
+else
+	   have-pci-set-dma-mask := 0
+endif
+
 EXTRA_CFLAGS = -DDRIVER_VERSION=$(hpi-version-string) \
 	-DHPI_OS_LINUX_KERNEL \
 	-DHPI_BUILD_DEBUG \
@@ -33,6 +45,8 @@
 	-DHPI_BUILD_INCLUDE_HPI6700 \
 	-DHPI_BUILD_INCLUDE_INTERNAL \
 	-DHPI_BUILD_EXCLUDE_ALL_DEPRECATED \
+	-DHAVE_PCI_SET_CONSISTENT_DMA_MASK=$(have-pci-set-consistent-dma-mask) \
+	-DHAVE_PCI_SET_DMA_MASK=$(have-pci-set-dma-mask) \
 	-O \
 	-I$(M)

=== deb/asihpi-dkms/debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: asihpi-dkms-4.20
 Section: sound
 Priority: optional
-Build-Depends: debhelper (>= 9), dkms (>= 2.1.0.0)
+Build-Depends: debhelper (>= 12), dkms (>= 2.1.0.0)
 Maintainer: AudioScience Linux developers <support@audioscience.com>
-Standards-Version: 3.9.7
+Standards-Version: 4.5.0
 
 Package: asihpi-dkms-4.20
 Architecture: all

=== deb/snd-asihpi-dkms/debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: snd-asihpi-dkms-4.20
 Section: sound
 Priority: optional
-Build-Depends: debhelper (>= 9), dkms (>= 2.1.0.0)
+Build-Depends: debhelper (>= 12), dkms (>= 2.1.0.0)
 Maintainer: AudioScience Linux developers <support@audioscience.com>
-Standards-Version: 3.9.7
+Standards-Version: 4.5.0
 
 Package: snd-asihpi-dkms-4.20
 Architecture: all

## hpklinux 4.20.48

=== alsa-drv/Makefile ===
--- 
+++ 
@@ -23,10 +23,22 @@
 
 obj-m += snd-asihpi.o
 
+ifeq ($(shell egrep -qw "strscpy" $(realpath $(srctree))/include/linux/*.h; echo $$?),0)
+	   have-strscpy := 1
+else
+	   have-strscpy := 0
+endif
+
 ifeq ($(shell egrep -qw "pci_set_consistent_dma_mask" $(realpath $(srctree))/include/linux/*.h; echo $$?),0)
 	   have-pci-set-consistent-dma-mask := 1
 else
 	   have-pci-set-consistent-dma-mask := 0
+endif
+
+ifeq ($(shell egrep -qw "dma_set_min_align_mask" $(realpath $(srctree))/include/linux/*.h; echo $$?),0)
+	   have-dma-set-min-align-mask := 1
+else
+	   have-dma-set-min-align-mask := 0
 endif
 
 ifeq ($(shell egrep -qw "pci_set_dma_mask" $(realpath $(srctree))/include/linux/*.h; echo $$?),0)
@@ -66,7 +78,9 @@
 	-DHAVE_SND_PCM_STOP_XRUN=$(have-snd-pcm-stop-xrun) \
 	-DHAVE_PCM_FORMAT_TO_BITS=$(have-pcm-format-to-bits) \
 	-DHAVE_SND_CTL_ENUM_INFO=$(have-snd-ctl-enum-info) \
-	-DHAVE_SND_CARD_NEW=$(have-snd-card-new)
+	-DHAVE_SND_CARD_NEW=$(have-snd-card-new) \
+	-DHAVE_DMA_SET_MIN_ALIGN_MASK=$(have-dma-set-min-align-mask) \
+	-DHAVE_STRSCPY=$(have-strscpy)
 
 else
 # Use the autoconf generated makefile for setup, install, dist targets etc.

=== asi-python/Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 setup: $(setup-files)
 
 build install: setup
-	python setup.py $(OPTS) $@ $(CMD_OPTS)
+	python2 setup.py $(OPTS) $@ $(CMD_OPTS)
 
 clean distclean:
 	rm -rf $(filter-out $(precious-files),$(wildcard *))

=== deb/Makefile ===
--- 
+++ 
@@ -25,9 +25,9 @@
 
 include hpi_version.mk
 
-distro-series = buster
+distro-series = buster focal jammy
 
-distro-archs = amd64 i386
+distro-archs = amd64
 
 series-from-path = $(notdir $(patsubst %/,%,$(dir $(1))))
 debpkg-changelog-files = $(addsuffix -changelog.in,$(debpkg-dir-names))

=== hpi-drv/Makefile ===
--- 
+++ 
@@ -31,6 +31,12 @@
 	   have-pci-set-consistent-dma-mask := 0
 endif
 
+ifeq ($(shell egrep -qw "dma_set_min_align_mask" $(realpath $(srctree))/include/linux/*.h; echo $$?),0)
+	   have-dma-set-min-align-mask := 1
+else
+	   have-dma-set-min-align-mask := 0
+endif
+
 ifeq ($(shell egrep -qw "pci_set_dma_mask" $(realpath $(srctree))/include/linux/*.h; echo $$?),0)
 	   have-pci-set-dma-mask := 1
 else
@@ -47,6 +53,7 @@
 	-DHPI_BUILD_EXCLUDE_ALL_DEPRECATED \
 	-DHAVE_PCI_SET_CONSISTENT_DMA_MASK=$(have-pci-set-consistent-dma-mask) \
 	-DHAVE_PCI_SET_DMA_MASK=$(have-pci-set-dma-mask) \
+	-DHAVE_DMA_SET_MIN_ALIGN_MASK=$(have-dma-set-min-align-mask) \
 	-O \
 	-I$(M)

=== deb/asihpi-dkms/debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: asihpi-dkms-4.20
 Section: sound
 Priority: optional
-Build-Depends: debhelper (>= 12), dkms (>= 2.1.0.0)
+Build-Depends: debhelper (>= 12), dh-sequence-dkms
 Maintainer: AudioScience Linux developers <support@audioscience.com>
 Standards-Version: 4.5.0

=== deb/asihpi-libs/debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: hpklinux
 Section: sound
 Priority: optional
-# FIXME: correct build-depends
-Build-Depends: debhelper (>= 9)
+Build-Depends: debhelper (>= 12)
 Maintainer: AudioScience Linux developers <support@audioscience.com>
-Standards-Version: 3.9.7
+Standards-Version: 4.5.0
 
 Package: libhpi
 Architecture: any
@@ -20,9 +19,16 @@
  This package contains the HPI library including access to
  AudioScience networked sound adapters.
 
+Package: libhpimux
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: libraries for  AudioScience HPI API including networking
+ This package contains the HPI library including access to
+ AudioScience networked sound adapters.
+
 Package: libhpi-dev
 Architecture: any
-Depends: ${misc:Depends}, libhpi (= ${binary:Version}), libhpiudp (= ${binary:Version})
+Depends: ${misc:Depends}, libhpi (= ${binary:Version}), libhpiudp (= ${binary:Version}), libhpimux (= ${binary:Version})
 Section: libdevel
 Description: development files for libhpi and libhpiudp
  This package contains the development files needed to build programs

=== deb/asihpi-meta/debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: sound
 Priority: optional
 Maintainer: AudioScience Linux Developers <linux@audioscience.com>
-Build-Depends: debhelper (>= 9.0.0)
-Standards-Version: 3.9.7
+Build-Depends: debhelper (>= 12)
+Standards-Version: 4.5.0
 #Homepage: <insert the upstream URL, if relevant>
 
 Package: snd-asihpi-dkms-4

=== deb/asihpi-utils/debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: asihpi-utils
 Section: sound
 Priority: optional
-Build-Depends: debhelper (>= 9), libhpi-dev (>= 4.20)
+Build-Depends: debhelper (>= 12), libhpi-dev (>= 4.20)
 Maintainer: AudioScience Linux developers <support@audioscience.com>
-Standards-Version: 3.9.7
+Standards-Version: 4.5.0
 
 Package: asihpi-utils
 Architecture: any

=== deb/python-audioscience/debian/control ===
Source: python-audioscience
Section: python
Priority: optional
Build-Depends: debhelper (>= 12), python3, python3-wheel, dh-python
Build-Depends-Indep: python3-setuptools
Maintainer: AudioScience Linux developers <linux@audioscience.com>
Standards-Version: 4.5.0
X-Python3-Version: >= 3.5

Package: python3-audioscience
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}, libhpi, libhpiudp
Description: Python binding for AudioScience HPI API
 audioscience.hpi - python3 bindings to HPI library

Package: python3-audioscience-utils
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}, python3, python3-audioscience, python3-tk
Description: Python scripts for AudioScience HPI API
 hpicontrol - to set/get controls, attributes, adapter mode
 hpimixer - Tk gui control and monitoring of mixer

=== deb/snd-asihpi-dkms/debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: snd-asihpi-dkms-4.20
 Section: sound
 Priority: optional
-Build-Depends: debhelper (>= 12), dkms (>= 2.1.0.0)
+Build-Depends: debhelper (>= 12), dh-sequence-dkms
 Maintainer: AudioScience Linux developers <support@audioscience.com>
 Standards-Version: 4.5.0

=== deb/python-audioscience/debian/rules ===
#! /usr/bin/make -f

# export DH_VERBOSE = 1

%:
	dh $@ --with python3 --buildsystem=pybuild

## hpklinux 4.30.18-g23f629632

=== hpi-cli-apps/Makefile ===
--- 
+++ 
@@ -43,9 +43,13 @@
 endif
 
 bins = asihpitest asihpiassert asihpitune asihpirec asihpiplay \
-	asi_firmware_updater asihpibl asihpirds asihpi_si4688
+	asi_firmware_updater asihpibl asihpirds asihpisetmode asihpi_si4688
+
 install-prefix ?= /usr/local
 bin-install-dir ?= $(install-prefix)/bin
+
+asihpisetmode: $(asihpisetmode-srcs)
+	$(CC) $(CFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm
 
 asihpirds: $(asihpirds-srcs)
 	$(CC) $(CFLAGS) $(LDFLAGS) $(INCLUDES) -o $@ $^ -lhpi -lm

=== hpi-drv/Makefile ===
# This is kbuild makefile for use with kernel build system
#
# Copyright (C) 1997-2017  AudioScience Inc. <support@audioscience.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License as
# published by the Free Software Foundation;
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# Usage:
# make -C <path-to-kernel-source> SUBDIRS=$PWD modules
# If you used O=<path-to-build-directory> for kernel build, use it here too

ifdef KBUILD_VERBOSE
# then we are coming from the kernel build system

include $(M)/hpi_version.mk

asihpi-objs := hpimod.o hpioctl.o hpicmn.o hpidebug.o hpimsgx.o hpios.o\
			hpi6000.o hpi6205.o hpi6700.o hpidspcd.o hpimsginit.o

obj-m += asihpi.o

EXTRA_CFLAGS = -DDRIVER_VERSION=$(hpi-version-string) \
	-DHPI_OS_LINUX_KERNEL \
	-DHPI_BUILD_DEBUG \
	-DHPI_BUILD_INCLUDE_HPI6000 \
	-DHPI_BUILD_INCLUDE_HPI6205 \
	-DHPI_BUILD_INCLUDE_HPI6700 \
	-DHPI_BUILD_INCLUDE_INTERNAL \
	-DHPI_BUILD_EXCLUDE_ALL_DEPRECATED \
	-DHPI_BUILD_NO_SHARED_GLOBALS \
	-O \
	-I$(M)

else
# Use the autoconf generated makefile for setup, install, dist targets etc.
include extra.mk
endif

=== hpi-lib/Makefile ===
--- 
+++ 
@@ -41,6 +41,7 @@
 	-DHPI_BUILD_DEBUG \
 	-DHPI_BUILD_INCLUDE_INTERNAL \
 	-DHPI_BUILD_EXCLUDE_ALL_DEPRECATED \
+	-DHPI_BUILD_NO_SHARED_GLOBALS \
 	-DnotHPI_BUILD_HPIDUMP 
 
 install-prefix ?= /usr/local

=== deb/asihpi-dkms/debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
-Source: asihpi-dkms-4.20
+Source: asihpi-dkms-4.29
 Section: sound
 Priority: optional
-Build-Depends: debhelper (>= 12), dh-sequence-dkms
+Build-Depends: debhelper (>= 9), dkms (>= 2.1.0.0)
 Maintainer: AudioScience Linux developers <support@audioscience.com>
-Standards-Version: 4.5.0
+Standards-Version: 3.9.7
 
-Package: asihpi-dkms-4.20
+Package: asihpi-dkms-4.29
 Architecture: all
 Depends: ${misc:Depends}
 Recommends: python

=== deb/asihpi-meta/debian/control ===
Source: asihpi-meta-4
Section: sound
Priority: optional
Maintainer: AudioScience Linux Developers <linux@audioscience.com>
Build-Depends: debhelper (>= 9.0.0)
Standards-Version: 3.9.7
#Homepage: <insert the upstream URL, if relevant>

Package: snd-asihpi-dkms-4
Architecture: all
Conflicts: asihpi-dkms-4
Depends: ${misc:Depends}, snd-asihpi-dkms-4.29
Description: ALSA driver for AudioScience cards
 This is a metapackage for users that want auto updates across minor versions.

Package: asihpi-dkms-4
Architecture: all
Conflicts: snd-asihpi-dkms-4
Depends: ${misc:Depends}, asihpi-dkms-4.29
Description: HPI driver for AudioScience cards
 This is a metapackage for users that want auto updates across minor versions.

=== deb/asihpi-utils/debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: asihpi-utils
 Section: sound
 Priority: optional
-Build-Depends: debhelper (>= 12), libhpi-dev (>= 4.20)
+Build-Depends: debhelper (>= 9), libhpi-dev (>= 4.29)
 Maintainer: AudioScience Linux developers <support@audioscience.com>
-Standards-Version: 4.5.0
+Standards-Version: 3.9.7
 
 Package: asihpi-utils
 Architecture: any

=== deb/snd-asihpi-dkms/debian/control ===
Source: snd-asihpi-dkms-4.29
Section: sound
Priority: optional
Build-Depends: debhelper (>= 9), dkms (>= 2.1.0.0)
Maintainer: AudioScience Linux developers <support@audioscience.com>
Standards-Version: 3.9.7

Package: snd-asihpi-dkms-4.29
Architecture: all
Provides: asihpi-driver
Conflicts: asihpi-driver
Depends: ${misc:Depends}
Recommends: python
Description: ALSA driver for AudioScience cards
 Contains the driver sources and DKMS configuration, plus
 card firmware
